/* History comments (TE):
   ======================

   05.12.2008:
   Changes in the headers which are included to make the code compile
   with g++ 4.3

   19.12.2008:
   Again changes in include statements to get C++ like include
   files instead of the C cousins (stdio.h -> cstdio etc.)
*/  

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cmath>
#include <vector>
#include "fitslib.h"
#include "fitsio.h"

using namespace std;

int single_key (string infile, string outfile, string key);
int many_keys (string infile, string outfile, string keyfile);
int usage ();


int main(int argc, char *argv[]) {
	if (argc<4) {
		usage();
		exit(1);
	}
	
	string infile = argv[1];
	string outfile = argv[2];
	string key = argv[3]; 
		
	printf("test%sfin\n",argv[3]);
	if (strncmp(argv[3],"@",1) == 0) {
	  	string keyfile;
		keyfile.assign(key,1,key.length()-1); 

		cout << "many keys ... " << keyfile << "\n";
		many_keys(infile,outfile,keyfile);	
	} else {
		cout << "one single key ... \n";
		single_key(infile,outfile,key);	
	}
	
	return 0;	
}

int single_key (string infile, string outfile, string key) {
	fits infits(infile);
	fits outfits(outfile);
	vector<string> keys;
	keys.push_back(key);
	outfits.cphead_str(infits,keys);
	return 0;
}
int many_keys(string infile,string outfile,string keyfile) {
	// Read the key file
	ifstream file;
	file.open(keyfile.c_str());
	vector<string> keys;	
	while (! file.eof() ) {
		string key;
		file >> key;	
		if (key != "") {
			keys.push_back(key);
		}
		cout << key << "\n";
	}
	file.close();
	fits infits(infile);
	fits outfits(outfile);
	outfits.cphead_str(infits,keys);
	return 0;	
}


int usage (){
	cout << "Usage : cphead infits outfits key/@key ...\n";	
	return 0;	
}
		 
