/**********************************************************/
/*                                                        */
/* FUNCTION:  alloc_square_float                          */
/*                                                        */
/* PURPOSE: Allocates a square of float in memory         */
/*                                                        */
/* INPUT:  nbr_lin = number of lines                      */
/*         nbr_col = number of columns                    */
/*                                                        */
/* RETURN: square = pointer to matrix of pointers         */
/*                (NULL if memory allocation failure)     */
/*                                                        */
/* VERSION: 1.1  March  1992                              */
/*                                                        */
/* AUTHOR: Karim BOUYOUCEF                                */
/*                                                        */
/**********************************************************/
#include <malloc.h>

/**********************************************************/
float	**alloc_square_float(int nbr_lin,int nbr_col) {
auto     float   **square;
register int      i, j;

square = (float **) malloc((unsigned) nbr_lin*sizeof(float *));
if (square != 0)
  {
  for (i=0; i<nbr_lin; i++)
    {
    square[i] = (float *)malloc((unsigned) nbr_col*sizeof(float));
    if (square[i] == 0) square = 0;
    }
  }

for (i=0; i<nbr_lin; i++)
for (j=0; j<nbr_col; j++)
square[i][j]=0.0;

return(square);
}
