#!/usr/lib/perl 

# HISTORY COMMENTS (TE):
#
# I moved the utilitiy function from this file to progs_lib.pl.
# The routine does not fit into this file which mostly contains
# Hough utility routines.

##################################################################
# Get the coordinates of the 4 corners of the images (period + chip)
##################################################################
sub get_chip_limits {
    my ($period,$chip) = @_;

    my %res = ();
    $res{'X_1_1'} = 1;
    $res{'X_X_1'} = 2038;
    $res{'X_1_Y'} = 1;
    $res{'X_X_Y'} = 2038;
    $res{'Y_1_1'} = 1;
    $res{'Y_X_1'} = 1;
    $res{'Y_1_Y'} = 4086;
    $res{'Y_X_Y'} = 4086;
    
    return %res;
}
sub get_chip_limits_instrum {
    my ($period,$chip,$instrum) = @_;

    my $confdir = $ENV{"PIPESOFT"}."/stracktools/conf/";
    my $file = $confdir."instrum_conf.ini";
    my %dd;
    &read_catc($file,\%dd);
    
    my $index = -1;
    foreach(@{$dd{"INSTRUMENT"}}) {
	$index++;
	if ($_ eq $instrum) {
	    last;
	}
    }
    
    if ($index == -1) {
	die "Instrument $instrument not found \n";
    }
    my %res = ();
    $res{'X_1_1'} = $dd{"XPIX_1"}->[$index];
    $res{'X_X_1'} = $dd{"XPIX_X"}->[$index];
    $res{'X_1_Y'} = $dd{"XPIX_1"}->[$index];
    $res{'X_X_Y'} = $dd{"XPIX_X"}->[$index];
    $res{'Y_1_1'} = $dd{"YPIX_1"}->[$index];
    $res{'Y_X_1'} = $dd{"YPIX_1"}->[$index];
    $res{'Y_1_Y'} = $dd{"YPIX_Y"}->[$index];
    $res{'Y_X_Y'} = $dd{"YPIX_Y"}->[$index];

    
    return %res;
}
# sub get_chip_limits_instrum_OLD {
#     my ($period,$chip,$instrum) = @_;
# 
#     my %res = ();
#     if ($instrum eq "CFH12K") {
# 	$res{'X_1_1'} = 1;
# 	$res{'X_X_1'} = 2038;
# 	$res{'X_1_Y'} = 1;
# 	$res{'X_X_Y'} = 2038;
# 	$res{'Y_1_1'} = 1;
# 	$res{'Y_X_1'} = 1;
# 	$res{'Y_1_Y'} = 4086;
# 	$res{'Y_X_Y'} = 4086;
#     } elsif ($instrum eq "MEGACAM" || $instrum eq "MEGAPRIME") {
# 	$res{'X_1_1'} = 1;
# 	$res{'X_X_1'} = 2043;
# 	$res{'X_1_Y'} = 1;
# 	$res{'X_X_Y'} = 2043;
# 	$res{'Y_1_1'} = 1;
# 	$res{'Y_X_1'} = 1;
# 	$res{'Y_1_Y'} = 4606;
# 	$res{'Y_X_Y'} = 4606;
#     } elsif ($instrum eq "WFI") {
# 	$res{'X_1_1'} = 1;
# 	$res{'X_X_1'} = 2046;
# 	$res{'X_1_Y'} = 1;
# 	$res{'X_X_Y'} = 2046;
# 	$res{'Y_1_1'} = 1;
# 	$res{'Y_X_1'} = 1;
# 	$res{'Y_1_Y'} = 4098;
# 	$res{'Y_X_Y'} = 4098;
#     } 
#     return %res;
# }
sub get_chip_limits_instrum_ind0 {
    my ($period,$chip,$instrum) = @_;

    my $confdir = $ENV{"PIPESOFT"}."/stracktools/conf/";
    my $file = $confdir."instrum_conf.ini";
    my %dd;
    &read_catc($file,\%dd);
    
    my $index = -1;
    foreach(@{$dd{"INSTRUMENT"}}) {
	$index++;
	if ($_ eq $instrum) {
	    last;
	}
    }
    
    if ($index == -1) {
	die "Instrument $instrument not found \n";
    }
    my %res = ();
    $res{'X_1_1'} = $dd{"XPIX_1"}->[$index]-1;
    $res{'X_X_1'} = $dd{"XPIX_X"}->[$index]-1;
    $res{'X_1_Y'} = $dd{"XPIX_1"}->[$index]-1;
    $res{'X_X_Y'} = $dd{"XPIX_X"}->[$index]-1;
    $res{'Y_1_1'} = $dd{"YPIX_1"}->[$index]-1;
    $res{'Y_X_1'} = $dd{"YPIX_1"}->[$index]-1;
    $res{'Y_1_Y'} = $dd{"YPIX_Y"}->[$index]-1;
    $res{'Y_X_Y'} = $dd{"YPIX_Y"}->[$index]-1;

    
    return %res;
}
# sub get_chip_limits_instrum_ind0_OLD {
#     my ($period,$chip,$instrum) = @_;
# 
#     my %res = ();
#     if ($instrum eq "CFH12K") {
# 	$res{'X_1_1'} = 0;
# 	$res{'X_X_1'} = 2037;
# 	$res{'X_1_Y'} = 0;
# 	$res{'X_X_Y'} = 2037;
# 	$res{'Y_1_1'} = 0;
# 	$res{'Y_X_1'} = 0;
# 	$res{'Y_1_Y'} = 4085;
# 	$res{'Y_X_Y'} = 4085;
#     } elsif ($instrum eq "MEGACAM" || $instrum eq "MEGAPRIME") {
# 	$res{'X_1_1'} = 0;
# 	$res{'X_X_1'} = 2042;
# 	$res{'X_1_Y'} = 0;
# 	$res{'X_X_Y'} = 2042;
# 	$res{'Y_1_1'} = 0;
# 	$res{'Y_X_1'} = 0;
# 	$res{'Y_1_Y'} = 4605;
# 	$res{'Y_X_Y'} = 4605;
#     } elsif ($instrum eq "WFI") {
# 	$res{'X_1_1'} = 0;
# 	$res{'X_X_1'} = 2045;
# 	$res{'X_1_Y'} = 0;
# 	$res{'X_X_Y'} = 2045;
# 	$res{'Y_1_1'} = 0;
# 	$res{'Y_X_1'} = 0;
# 	$res{'Y_1_Y'} = 4097;
# 	$res{'Y_X_Y'} = 4097;
#     } 
#     return %res;
# }
sub get_chip_limits_bin {
    my ($period,$chip,$bin) = @_;

    my %res = ();
    $res{'X_1_1'} = 1;
    $res{'X_X_1'} = int(2038/$bin + 0.5);
    $res{'X_1_Y'} = 1;
    $res{'X_X_Y'} = int(2038/$bin + 0.5);
    $res{'Y_1_1'} = 1;
    $res{'Y_X_1'} = 1;
    $res{'Y_1_Y'} = int(4086/$bin + 0.5);
    $res{'Y_X_Y'} = int(4086/$bin + 0.5);
    
    return %res;
}
sub get_chip_limits_bin_instrum {
    my ($period,$chip,$bin,$instrum) = @_;

    my %ress = ();
    my %res = ();
    my $confdir = $ENV{"PIPESOFT"}."/stracktools/conf/";
    my $file = $confdir."instrum_conf.ini";
    my %dd;
    &read_catc($file,\%dd);
    
    my $index = -1;
    foreach(@{$dd{"INSTRUMENT"}}) {
	$index++;
	if ($_ eq $instrument) {
	    die;
	}
    }
    
    if ($index == -1) {
	die "Instrument $instrument not found \n";
    }

    $ress{'X_1_1'} = $dd{"XPIX_1"}->[$index];
    $ress{'X_X_1'} = $dd{"XPIX_X"}->[$index];
    $ress{'X_1_Y'} = $dd{"XPIX_1"}->[$index];
    $ress{'X_X_Y'} = $dd{"XPIX_X"}->[$index];
    $ress{'Y_1_1'} = $dd{"YPIX_1"}->[$index];
    $ress{'Y_X_1'} = $dd{"YPIX_1"}->[$index];
    $ress{'Y_1_Y'} = $dd{"YPIX_Y"}->[$index];
    $ress{'Y_X_Y'} = $dd{"YPIX_Y"}->[$index];


    
    $res{'X_1_1'} = $ress{'X_1_1'};
    $res{'X_X_1'} = int($ress{'X_X_1'}/$bin + 0.5);
    $res{'X_1_Y'} = $ress{'X_1_Y'};
    $res{'X_X_Y'} = int($ress{'X_X_Y'}/$bin + 0.5);
    $res{'Y_1_1'} = $ress{'Y_1_1'};
    $res{'Y_X_1'} = $ress{'Y_X_1'};
    $res{'Y_1_Y'} = int($ress{'Y_1_Y'}/$bin + 0.5);
    $res{'Y_X_Y'} = int($ress{'Y_X_Y'}/$bin + 0.5);
    

    return %res;
}
# sub get_chip_limits_bin_instrum_OLD {
#     my ($period,$chip,$bin,$instrum) = @_;
# 
#     my %res = ();
#     if ($instrum eq "CFH12K") {
# 	$res{'X_1_1'} = 1;
# 	$res{'X_X_1'} = int(2038/$bin + 0.5);
# 	$res{'X_1_Y'} = 1;
# 	$res{'X_X_Y'} = int(2038/$bin + 0.5);
# 	$res{'Y_1_1'} = 1;
# 	$res{'Y_X_1'} = 1;
# 	$res{'Y_1_Y'} = int(4086/$bin + 0.5);
# 	$res{'Y_X_Y'} = int(4086/$bin + 0.5);
#     } elsif ($instrum eq "MEGACAM" || $instrum eq "MEGAPRIME") {
# 	$res{'X_1_1'} = 1;
# 	$res{'X_X_1'} = int(2043/$bin + 0.5);
# 	$res{'X_1_Y'} = 1;
# 	$res{'X_X_Y'} = int(2043/$bin + 0.5);
# 	$res{'Y_1_1'} = 1;
# 	$res{'Y_X_1'} = 1;
# 	$res{'Y_1_Y'} = int(4606/$bin + 0.5);
# 	$res{'Y_X_Y'} = int(4606/$bin + 0.5);
#     } elsif ($instrum eq "WFI") {
# 	$res{'X_1_1'} = 1;
# 	$res{'X_X_1'} = int(2032/$bin + 0.5);
# 	$res{'X_1_Y'} = 1;
# 	$res{'X_X_Y'} = int(2032/$bin + 0.5);
# 	$res{'Y_1_1'} = 1;
# 	$res{'Y_X_1'} = 1;
# 	$res{'Y_1_Y'} = int(4092/$bin + 0.5);
# 	$res{'Y_X_Y'} = int(4092/$bin + 0.5);
#     }
# 
#     return %res;
# }
####################################################################
# Get the coordinates on the projected mosaic of the 4 corners of the chips 
# period 1 : 24/03/1999 (GABODSID 82)  - 02/11/1999 (GABODSID 305)
# period 2 : 02/11/1999 (GABODSID 305) - 28/05/2000 (GABODSID 514)
# period 3 : 28/05/2000 (GABODSID 514) - ........
####################################################################
sub get_chippix_mosaic {
    my ($period,$chip) = @_;
    
    
    my $config = "Strack_CFH12K.ini";
    my $dir = $ENV{'HOME'}."/perl/lib/";
    my $dir2 = $ENV{'HOME'}."/scripts/lib/";
    if (-d $dir) {
	$config = $dir.$config;
    } elsif  (-d $dir2) {
	$config = $dir2.$config;
    }

    
    my %data;
    &read_catc($config,\%data);

    my %res = ();
    #@{$res{'X'}} = (0,0,0,0);
    #@{$res{'Y'}} = (0,0,0,0);

    my $ii = -1;
    foreach (@{$data{'PERIOD'}}) {
	$ii++;

	$tmp1 = $data{'PERIOD'}->[$ii];
	$tmp2 = $data{'CHIP'}->[$ii];
	
	if ($data{'CHIP'}->[$ii] == $chip && $data{'PERIOD'}->[$ii] eq $period) {
	    $res{'X_1_1'}=$data{'X_1_1'}->[$ii];
	    $res{'X_X_1'}=$data{'X_X_1'}->[$ii];
	    $res{'X_1_Y'}=$data{'X_1_Y'}->[$ii];
	    $res{'X_X_Y'}=$data{'X_X_Y'}->[$ii];
	    $res{'Y_1_1'}=$data{'Y_1_1'}->[$ii];
	    $res{'Y_X_1'}=$data{'Y_X_1'}->[$ii];
	    $res{'Y_1_Y'}=$data{'Y_1_Y'}->[$ii];
	    $res{'Y_X_Y'}=$data{'Y_X_Y'}->[$ii];
	}
    }
    return %res;
}
################
sub get_chippix_mosaic_instrum {
    my ($period,$chip,$instrum) = @_;
    my $config;
    # if ($instrum eq "CFH12K") {
    # 	$config = "Strack_CFH12K.ini";
    # } elsif ($instrum eq "MEGACAM" || $instrum eq "MEGAPRIME") {
    # 	$config = "Strack_MEGACAM.ini";
    # } elsif ($instrum eq "WFI") {
    # 	$config = "Strack_WFI.ini";
    # }

    $config = "Strack_".$instrum.".ini";

    my $dir = $ENV{'PIPESOFT'}."/stracktools/conf/";
    #my $dir = $ENV{'HOME'}."/perl/lib/";
    my $dir2 = $ENV{'HOME'}."/scripts/lib/";
    
    if (-d $dir) {
	$config = $dir.$config;
    } elsif  (-d $dir2) {
	$config = $dir2.$config;
    }

    
    my %data;
    #print "Read param in $config \n";
    &read_catc($config,\%data);

    my %res = ();
    #@{$res{'X'}} = (0,0,0,0);
    #@{$res{'Y'}} = (0,0,0,0);

    my $ii = -1;
    foreach (@{$data{'PERIOD'}}) {
	$ii++;

	$tmp1 = $data{'PERIOD'}->[$ii];
	$tmp2 = $data{'CHIP'}->[$ii];
	
	
	if ($data{'CHIP'}->[$ii] == $chip && $data{'PERIOD'}->[$ii] eq $period) {
	    $res{'X_1_1'}=$data{'X_1_1'}->[$ii];
	    $res{'X_X_1'}=$data{'X_X_1'}->[$ii];
	    $res{'X_1_Y'}=$data{'X_1_Y'}->[$ii];
	    $res{'X_X_Y'}=$data{'X_X_Y'}->[$ii];
	    $res{'Y_1_1'}=$data{'Y_1_1'}->[$ii];
	    $res{'Y_X_1'}=$data{'Y_X_1'}->[$ii];
	    $res{'Y_1_Y'}=$data{'Y_1_Y'}->[$ii];
	    $res{'Y_X_Y'}=$data{'Y_X_Y'}->[$ii];
	}
    }
    return %res;
}
####################################################################
# Get the points coordinates + side of the intersection line/boarder
# input : line (r,theta) hough coordinates
#       : limits (corner coordinates (x1,x2,x3,x4),(y1,y2,y3,y4))
# output: point1 (ratio,side)
#       : point2 (ratio,side)    (pointers)
####################################################################
sub get_pointside_chip {
    my($line,$limits,$PP1,$PP2) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    $r = $line->[0];
    my @eq_ref = ($cost,$sint,$r);

    #print "line r = $r theta = ".$line->[1]." \n";

    # side1
    #if (defined $debug) {
    #	print "side 1 \n";
    #}
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[0],$p2[0]);
# 
# if (defined 1) {
# 	print "print points for line @p1 @p2 \n";
# }
# 
    my @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "side1 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(1,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(1,\@PP2,\@lim);    
             #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }


    # side2
    if (defined $debug) {
	print "side 1 \n";
    }
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[1],$p2[1]);
#     
#      if (defined 1) {
#  	print "print points for line @p1 @p2 \n";
#      }
# 
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "side2 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(2,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(2,\@PP2,\@lim);
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side3
    if (defined $debug) {
	print "side 1 \n";
    }
    @p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @lim = ($p1[0],$p2[0]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "side3 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(3,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(3,\@PP2,\@lim);
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side4
    if (defined $debug) {
	print "side 1 \n";
    }
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "side4 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(4,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(4,\@PP2,\@lim);
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    #print "testt @P1 @P2 \n";

    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }

}
####################################################################
# Get the points coordinates + side of the intersection line/boarder
# input : line (r,theta) hough coordinates
#       : limits (corner coordinates (x1,x2,x3,x4),(y1,y2,y3,y4))
# output: point1 (ratio,side)
#       : point2 (ratio,side)    (pointers)
####################################################################
sub get_pointside_mos {
    my($line,$limits,$PP1,$PP2,$ref) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    $r = $line->[0];
    my @eq_ref = ($cost,$sint,$r + $ref->[0]* $cost + $ref->[1] * $sint);

    if (defined $debug) {
	print "line r = $r theta = ".$line->[1]." \n";
	print "line @eq_ref \n";
    }

    # side1
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[0],$p2[0]);
    my @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "side1 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && (($int[0] >= $p1[0] && $int[0] <= $p2[0])||($int[0] <= $p1[0] && $int[0] >= $p2[0]))) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(1,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(1,\@PP2,\@lim);    
             #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }


    # side2
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "side2 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && (($int[1] >= $p1[1] && $int[1] <= $p2[1])||($int[1] <= $p1[1] && $int[1] >= $p2[1]))) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(2,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(2,\@PP2,\@lim);
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side3
    @p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @lim = ($p1[0],$p2[0]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "side3 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && (($int[0] >= $p1[0] && $int[0] <= $p2[0])||($int[0] <= $p1[0] && $int[0] >= $p2[0]))) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(3,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(3,\@PP2,\@lim);
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side4
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "side4 int @int eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && (($int[1] >= $p1[1] && $int[1] <= $p2[1])||($int[1] <= $p1[1] && $int[1] >= $p2[1]))) {
	if ($P1[0] eq "NaN") {
	    @PP1 = ($int[0],$int[1]);
	    @P1 = transform_p_rside(4,\@PP1,\@lim);
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @PP2 = ($int[0],$int[1]);
	    @P2 = transform_p_rside(4,\@PP2,\@lim);
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    #print "testt @P1 @P2 \n";

    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }

}
####################################################################
# Get the equation of the side of the image where the line hits
# input : line (r,theta) hough coordinates
#       : limits (corner coordinates (x1,x2,x3,x4),(y1,y2,y3,y4))
# output: line1 (r,theta)
#       : line2 (r,theta)    (pointers)
####################################################################
sub get_eqside_chip {
    my($line,$limits,$PP1,$PP2,$side) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");
    #my @ref = (1,1);
    my @ref = (0,0);

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    $r = $line->[0];
    my @eq_ref = ($cost,$sint,$r);

    #print "line r = $r theta = ".$line->[1]." \n";

    # side1
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[0],$p2[0]);
    my @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "side1 eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	@leq = get_hougheq(\@p1,\@p2,\@ref);
	push(@$side,1);
	if ($P1[0] eq "NaN") {
	    @P1 = @leq;
	} elsif ($P2[0] eq "NaN") {
	    @P2 = @leq; 
             #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }


    # side2
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "side2 eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	push(@$side,2);
	@leq = get_hougheq(\@p1,\@p2,\@ref);
	if ($P1[0] eq "NaN") {
	    @P1 = @leq;
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @P2 = @leq;
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side3
    @p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @lim = ($p1[0],$p2[0]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "@int side3 eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	@leq = get_hougheq(\@p1,\@p2,\@ref);
	push(@$side,3);
	if ($P1[0] eq "NaN") {
	    @P1 = @leq;
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @P2 = @leq;
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side4
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    # print "side4  eq @eq and points @p1 @p2 \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	@leq = get_hougheq(\@p1,\@p2,\@ref);
	push(@$side,4);
	if ($P1[0] eq "NaN") {
	    @P1 = @leq;
	    #print "case1 \n";
	} elsif ($P2[0] eq "NaN") {
	    @P2 = @leq;
	    #print "case2 \n";
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    
    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }

}
####################################################################
# Get the points coordinates of the intersection line/boarder
# input : line (r,theta) hough coordinates
#       : limits (corner coordinates (x1,x2,x3,x4),(y1,y2,y3,y4))
# output: point1 (ratio,side)
#       : point2 (ratio,side)    (pointers)
####################################################################
sub get_point_chip {
    my($line,$limits,$PP1,$PP2) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    $r = $line->[0];
    my @eq_ref = ($cost,$sint,$r);

    #print "line r = $r theta = ".$line->[1]." \n";

    # side1
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[0],$p2[0]);
    my @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 1 @int \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side2
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 2 @int \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side3
    @p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @lim = ($p1[0],$p2[0]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 3 @int \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side4
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 4 @int \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    #print "testt @P1 @P2 \n";

    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }

}
####################################################################
# Get the points coordinates of the intersection line/boarder
# input : line (r,theta) hough coordinates
#       : limits (corner coordinates (x1,x2,x3,x4),(y1,y2,y3,y4))
# output: point1 (ratio,side)
#       : point2 (ratio,side)    (pointers)
####################################################################
sub get_point_chip_ref {
    my($line,$limits,$PP1,$PP2,$ref) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    #$r = $line->[0];
    $r = $line->[0] + $ref->[0] * $cost + $ref->[1] * $sint;
    my @eq_ref = ($cost,$sint,$r);

    #print "line r = $r theta = ".$line->[1]." \n";

    # side1
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[0],$p2[0]);
    my @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 1 @int \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side2
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 2 @int \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side3
    @p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @lim = ($p1[0],$p2[0]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 3 @int \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side4
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 4 @int \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    #print "testt @P1 @P2 \n";

    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }
    

}
####################################################################
# Get the points coordinates of the intersection line/boarder
# input : line (r,theta) hough coordinates
#       : limits (corner coordinates (x1,x2,x3,x4),(y1,y2,y3,y4))
# output: point1 (ratio,side)
#       : point2 (ratio,side)    (pointers)
####################################################################
sub get_point_chip_side {
    my($line,$limits,$PP1,$PP2,$side) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    $r = $line->[0];
    my @eq_ref = ($cost,$sint,$r);

    #print "line r = $r theta = ".$line->[1]." \n";

    # side1
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[0],$p2[0]);
    my @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 1 @int \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	push(@$side,1);
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side2
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 2 @int \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	push(@$side,2);
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side3
    @p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    @lim = ($p1[0],$p2[0]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 3 @int \n";
    if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	push(@$side,3);
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    # side4
    @p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
    @p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    @lim = ($p1[1],$p2[1]);
    @eq = &line_eq(\@p1,\@p2);
    @int = &get_intersect(\@eq,\@eq_ref);
    #print "case 4 @int \n";
    if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	push(@$side,4);
	if ($P1[0] eq "NaN") {
	    @P1 = ($int[0],$int[1]);
	} elsif ($P2[0] eq "NaN") {
	    @P2 = ($int[0],$int[1]);
	} else {
	    die "Big problem ... 3 intersections points \n";
	}
    }

    #print "testt @P1 @P2 \n";

    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }

}
####################################################################
# Get the points coordinates of the intersection line/boarder
# input : line (r,theta) hough coordinates
#       : limits (corner coordinates (x1,x2,x3,x4),(y1,y2,y3,y4))
# output: point1 (ratio,side)
#       : point2 (ratio,side)    (pointers)
####################################################################
sub get_point_chip_side_fixed_OLD {
    my($line,$limits,$PP1,$PP2,$side) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    $r = $line->[0];
    my @eq_ref = ($cost,$sint,$r);

    #print "line r = $r theta = ".$line->[1]." \n";

    # side1
    if ($side->[0] == 1 || $side->[1] == 1) {
	@p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
	@p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
	@lim = ($p1[0],$p2[0]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 1 @int \n";
	if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	    #push(@$side,1);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    # side2
    if ($side->[0] == 2 || $side->[1] == 2) {
	@p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
	@p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
	@lim = ($p1[1],$p2[1]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 2 @int \n";
	if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	    #push(@$side,2);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    # side3
    if ($side->[0] == 3 || $side->[1] == 3) {
	@p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
	@p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
	@lim = ($p1[0],$p2[0]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 3 @int \n";
	if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	    #push(@$side,3);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    # side4
    if ($side->[0] == 4 || $side->[1] == 4) {
	@p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
	@p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
	@lim = ($p1[1],$p2[1]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 4 @int \n";
	if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	    #push(@$side,4);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    #print "testt @P1 @P2 \n";

    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }

}
####################################################################
####################################################################
sub get_point_chip_side_fixed {
    my($line,$limits,$PP1,$PP2,$side) = @_;
    @P1 = ("NaN","NaN");
    @P2 = ("NaN","NaN");

    # convert line in equation X cos(theta) + Y sin(theta) = r
    $cost = cos($line->[1]);
    $sint = sin($line->[1]);
    $r = $line->[0];
    my @eq_ref = ($cost,$sint,$r);

    #print "line r = $r theta = ".$line->[1]." \n";

    # side1
    if ($side->[0] == 1 || $side->[1] == 1) {
	@p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
	@p2 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
	@lim = ($p1[0],$p2[0]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 1 @int \n";
	#if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($int[0] ne "NaN") {
	    #push(@$side,1);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    # side2
    if ($side->[0] == 2 || $side->[1] == 2) {
	@p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
	@p1 =  ($limits->{'X_X_1'},$limits->{'Y_X_1'});
	@lim = ($p1[1],$p2[1]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 2 @int \n";
	#if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($int[0] ne "NaN") {
	    #push(@$side,2);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    # side3
    if ($side->[0] == 3 || $side->[1] == 3) {
	@p1 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
	@p2 =  ($limits->{'X_X_Y'},$limits->{'Y_X_Y'});
	@lim = ($p1[0],$p2[0]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 3 @int \n";
	#if ($int[0] ne "NaN" && $int[0] >= $p1[0] && $int[0] <= $p2[0]) {
	if ($int[0] ne "NaN") {
	    #push(@$side,3);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    # side4
    if ($side->[0] == 4 || $side->[1] == 4) {
	@p1 =  ($limits->{'X_1_1'},$limits->{'Y_1_1'});
	@p2 =  ($limits->{'X_1_Y'},$limits->{'Y_1_Y'});
	@lim = ($p1[1],$p2[1]);
	my @eq = &line_eq(\@p1,\@p2);
	@int = &get_intersect(\@eq,\@eq_ref);
	#print "case 4 @int \n";
	#if ($int[0] ne "NaN" && $int[1] >= $p1[1] && $int[1] <= $p2[1]) {
	if ($int[0] ne "NaN") {
	    #push(@$side,4);
	    if ($P1[0] eq "NaN") {
		@P1 = ($int[0],$int[1]);
	    } elsif ($P2[0] eq "NaN") {
		@P2 = ($int[0],$int[1]);
	    } else {
		die "Big problem ... 3 intersections points \n";
	    }
	}
    }

    #print "testt @P1 @P2 \n";

    if ($P1[0] ne "NaN" && $P2[0] ne "NaN") {
	$PP1->[0] = $P1[0];
	$PP1->[1] = $P1[1];
	$PP2->[0] = $P2[0];
	$PP2->[1] = $P2[1];
    } else {
	$PP1->[0] = "NaN";
	$PP1->[1] = "NaN";
	$PP2->[0] = "NaN";
	$PP2->[1] = "NaN";
	#die "Big Problem no intersection \n";
    }

}
####################################################################
# Intersection point of two lines 
# input : eq1 A x + B y = C
#       : eq2 a x + b y = c
# output: X Y 
####################################################################
sub get_intersect {
    my ($eq1,$eq2) = @_;
    my $a = $eq1->[0];
    my $b = $eq1->[1];
    my $c = $eq2->[0];
    my $d = $eq2->[1];

    my $det = $a * $d - $b * $c;
    if ($det == 0) {
	return ("NaN","NaN");
    } else {
	$res1 = 1/$det*($d * $eq1->[2] - $b * $eq2->[2]);
	$res2 = 1/$det*(- $c * $eq1->[2] + $a * $eq2->[2]);
	return ($res1,$res2);
    }
}
####################################################################
# Intersection point of two lines 
# input : eq1 (r,theta)
#       : eq2 (r,theta)
# output: X Y 
####################################################################
sub get_intersect_hough {
    my ($eq1,$eq2,$ref) = @_;
    my $a = cos($eq1->[1]);
    my $b = sin($eq1->[1]);
    my $c = cos($eq2->[1]);
    my $d = sin($eq2->[1]);

    my $det = $a * $d - $b * $c;
    if ($det == 0) {
	return ("NaN","NaN");
    } else {
	$res1 = 1/$det*($d * $eq1->[0] - $b * $eq2->[0])+$ref->[0];
	$res2 = 1/$det*(- $c * $eq1->[0] + $a * $eq2->[0])+$ref->[1];
	return ($res1,$res2);
    }
}
####################################################################
# Equation of line with two point
# input : P1 (x,y) P2 (x,y)
# output: eq2 a x + b y = c (a,b,c)
####################################################################
sub line_eq {
    my ($p1,$p2) = @_;
    
    if ($p1->[0] != $p2->[0]) {
	$aa = -($p2->[1] - $p1->[1]) / ($p2->[0] - $p1->[0]);
	$bb = $p2->[1] + $aa * $p2->[0];
	return ($aa,1,$bb);
    } else {
	return (1,0,$p2->[0]);
    }
}
######################################################################
sub transform_p_rside {
    my ($side,$P,$lim) = @_;

    if ($side == 1) {
	$ratio = ($P->[0] - $lim->[0]) / ($lim->[1] - $lim->[0]); 
    } elsif ($side == 2) {
	$ratio = ($P->[1] - $lim->[0]) / ($lim->[1] - $lim->[0]); 
    } elsif ($side == 3) {
	$ratio = ($P->[0] - $lim->[0]) / ($lim->[1] - $lim->[0]); 
    } elsif ($side == 4) {
	$ratio = ($P->[1] - $lim->[0]) / ($lim->[1] - $lim->[0]); 
    } else {
	die "Bad side $side \n";
    }
    return ($ratio,$side);
}
######################################################################
# Transform chip point ($ratio,$side) in mosaic point (X,Y)
# limits = lim{'XY_1XY_1XY'} ...
######################################################################
sub transform_chip_mos {
    my ($ratio,$side,$limits) = @_;
    my $x;my $y;

    #print "limits    ".$limits->{'X_X_1'}."\n";

    if ($side == 1) {
	@lims = ($limits->{'X_1_1'},$limits->{'Y_1_1'},$limits->{'X_X_1'},$limits->{'Y_X_1'});
    } elsif ($side == 2) {
	@lims = ($limits->{'X_X_1'},$limits->{'Y_X_1'},$limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    } elsif ($side == 3) {
	@lims = ($limits->{'X_1_Y'},$limits->{'Y_1_Y'},$limits->{'X_X_Y'},$limits->{'Y_X_Y'});
    } elsif ($side == 4) {
	@lims = ($limits->{'X_1_1'},$limits->{'Y_1_1'},$limits->{'X_1_Y'},$limits->{'Y_1_Y'});
    } else {
	die "Bad side $side \n";
    }

    #print "lims @lims \n";

    $x = ($lims[2] - $lims[0]) * $ratio + $lims[0];
    $y = ($lims[3] - $lims[1]) * $ratio + $lims[1];
    
    return ($x,$y);
}
######################################################################
# get the hough transform equation from two points + reference point 
# r >= 0 and theta in [0,2pi] (ref = Ox counterclockwise)
# output (r,theta)
######################################################################
sub get_hougheq {
    my ($p1,$p2,$ref) = @_;

    #print "test p ".$p2->[0]." ".$p1->[0]."\n";
      

    if ($p2->[0] - $p1->[0] != 0) {    # non vertical line
	#print "Non vertical line \n";
#    if (1) {    # non vertical line
	# line equation
	my $a = ($p2->[1] - $p1->[1]) / ($p2->[0] - $p1->[0]);
	my $b = $p2->[1] - $a * $p2->[0];
	my @eq1 = (-$a,1,$b);
	
	#print "ref = ".$ref->[0]." ".$ref->[1]." \n";
	
	# second line (perpandicular to first line)
	my @eq2 = ();
	if ($a != 0) {
	    my $aa = -1/$a;
	    my $bb = $ref->[1] - $aa * $ref->[0];
	    @eq2 = (-$aa,1,$bb);
	} else {
	    #@eq2 = (1,0,$p2->[0]);
	    @eq2 = (1,0,1);
	}
	
	# intersection
	my @P = get_intersect(\@eq1,\@eq2);
	
	my $r = sqrt(($P[0] - $ref->[0])*($P[0] - $ref->[0])+($P[1] - $ref->[1])*($P[1] - $ref->[1]));
	my $theta = atan2($P[1] - $ref->[1],$P[0] - $ref->[0]);
	#print "R = $r et $theta \n";
	
	if ($theta < 0) {
	    $theta = 2 * 3.1415927 + $theta;
	}
	return ($r,$theta);
    } else {                           # vertical line
	return ($p1->[0],0.0);
    }

    #return ($r,$theta);
}
######################################################################
# Transform a chip line in a mosaic line
# ref : reference point for global hough (coordinates + from Ox counterclock)
######################################################################
sub trans_line {

    my ($limits_chip,$limits_mos,$line_in,$line_out,$ref) = @_;

    my @pp1 = (); my @pp2 = ();
    &get_pointside_chip($line_in,$limits_chip,\@pp1,\@pp2);
    if ($pp1[0] eq "NaN") {
	push(@$line_out,"NaN");
	push(@$line_out,"NaN");
	print "Undefined line \n";
	return;
    }

    my $x1;my $y1; my $x2; my $y2;

    ($x1,$y1) = transform_chip_mos($pp1[0],$pp1[1],$limits_mos);
    ($x2,$y2) = transform_chip_mos($pp2[0],$pp2[1],$limits_mos);
    
    my @PP1 = ($x1,$y1);
    my @PP2 = ($x2,$y2);
 
    my ($rn,$thetan) = get_hougheq(\@PP1,\@PP2,$ref);
    #print "($rn,$thetan) of @PP1 and @PP2 \n";

    
    push(@$line_out,$rn);
    push(@$line_out,$thetan);
}
######################################################################
# Transform a mosaic line in a chip line
# ref : reference point for global hough (coordinates + from Ox counterclock)
######################################################################
sub trans_line2 {

    my ($limits_chip,$limits_mos,$line_in,$line_out,$ref) = @_;

    my @pp1 = (); my @pp2 = ();
    &get_pointside_mos($line_in,$limits_mos,\@pp1,\@pp2,$ref);
    if ($debug) {
	my @tmp = @$line_in;
	print "Equation @tmp and pt @pp1 and @pp2 \n";
    }
    if ($pp1[0] eq "NaN") {
	push(@$line_out,"NaN");
	push(@$line_out,"NaN");
	print "Undefined line \n";
	return;
    }

    if (defined $debug) {
	print "point @pp1 @pp2 \n";
    }

    my $x1;my $y1; my $x2; my $y2;

    ($x1,$y1) = transform_chip_mos($pp1[0],$pp1[1],$limits_chip);
    ($x2,$y2) = transform_chip_mos($pp2[0],$pp2[1],$limits_chip);
    
    if (defined $debug) {
	print "essai ($x1,$y1) ($x2,$y2) \n";
    }

    my @PP1 = ($x1,$y1);
    my @PP2 = ($x2,$y2);
 
    #@ref = (1,1);
    my @ref = (0,0);
    my ($rn,$thetan) = get_hougheq(\@PP1,\@PP2,\@ref);
    
    if (defined $debug) {
	print "final mos eq $rn , $thetan \n";
    }

    #push(@$line_out,$rn);
    #push(@$line_out,$thetan);
    $line_out->[0] = $rn;
    $line_out->[1] = $thetan;
    
}
######################################################################
# Check which chips crosses a line on a mosaic
# ref (reference point for hough equations)
# instrument
######################################################################
sub check_linechip {
    my ($line,$ref,$instrument,$period) = @_;
    my $il = -1;
    my @crossed_chips = ();
    
    my @xline = (); my @yline= ();
    push(@{$xline[1]},("X_1_1","X_X_1"));
    push(@{$xline[2]},("X_X_1","X_X_Y"));
    push(@{$xline[3]},("X_1_Y","X_X_Y"));
    push(@{$xline[4]},("X_1_1","X_1_Y"));
    push(@{$yline[1]},("Y_1_1","Y_X_1"));
    push(@{$yline[2]},("Y_X_1","Y_X_Y"));
    push(@{$yline[3]},("Y_1_Y","Y_X_Y"));
    push(@{$yline[4]},("Y_1_1","Y_1_Y"));
    
    if ($instrument eq "CFH12K") {

	if ($period == 1) {
	    my @lchip = (1,2,3,4,5,7,8,9,10,11);
	    foreach(@lchip) {
		#$chip = 11;
		#print "Working on chip $_ **** \n";
		
		my $chip = $_;
		my %limits = get_chippix_mosaic($period,$chip);
		
		# Loop on the chip sides
		my $flag = 0;
		for ($il=1;$il<=4;$il++) {
		    #print "Working on side $il \n";

                    # calculate equation
		    my @p1 = ($limits{$xline[$il]->[0]},$limits{$yline[$il]->[0]});
		    my @p2 = ($limits{$xline[$il]->[1]},$limits{$yline[$il]->[1]});
		    my @ref_eq =  get_hougheq(\@p1,\@p2,$ref);
		    
		    my @tmp1 = @$line;
		    my @tmp2 = @$ref;

		    my @inter = get_intersect_hough($line,\@ref_eq,$ref);    
		    
		    if ($inter[0] =~ /NaN/) {
			next;
		    }

		    # is it in the chip ?
		    if (($inter[0] >= $limits{$xline[$il]->[0]} && $inter[0] <= $limits{$xline[$il]->[1]}) || ($inter[0] <= $limits{$xline[$il]->[0]} && $inter[0] >= $limits{$xline[$il]->[1]})) {
			if (($inter[1] >= $limits{$yline[$il]->[0]} && $inter[1] <= $limits{$yline[$il]->[1]}) || ($inter[1] <= $limits{$yline[$il]->[0]} && $inter[1] >= $limits{$yline[$il]->[1]})) {
			    $flag = 1;
			    #print "YES is in chip \n";
			    last;
			}
		    }
		}
		
		# inside ?
		if ($flag == 1) {
		    push(@crossed_chips,$chip);
		}
	       
	    }
	} elsif ($period != 1) {
	    my @lchip = (1,2,3,4,5,6,7,8,9,10,11,12);
	    foreach(@lchip) {
		#print "Check chip $_ \n";

		my $chip = $_;
		my %limits = get_chippix_mosaic($period,$chip);
		
		# Loop on the chip sides
		my $flag = 0;
		for ($il=1;$il<=4;$il++) {
		    #print "Check line $il \n";

                    # calculate equation
		    my @p1 = ($limits{$xline[$il]->[0]},$limits{$yline[$il]->[0]});
		    my @p2 = ($limits{$xline[$il]->[1]},$limits{$yline[$il]->[1]});
		    my @ref_eq =  get_hougheq(\@p1,\@p2,$ref);
		    
		    #print "ref equation of @p1 et @p2 is @ref_eq \n";

		    my @eq1 = ($line->[0],$line->[1]);
		    my @eq2 = ($ref_eq[0],$ref_eq[1]);
		    #my @inter = get_intersect_hough($line,\@ref_eq);
		    my @inter = get_intersect_hough(\@eq1,\@eq2,$ref);
		    if ($inter[0] =~ /NaN/) {
			next;
		    }
		    my @tmp = @$line;
		    #print "inter @inter of @eq1 and @eq2 \n";

		    # is it in the chip ?
		    if (($inter[0] >= $limits{$xline[$il]->[0]} && $inter[0] <= $limits{$xline[$il]->[1]}) || ($inter[0] <= $limits{$xline[$il]->[0]} && $inter[0] >= $limits{$xline[$il]->[1]})) {
			if (($inter[1] >= $limits{$yline[$il]->[0]} && $inter[1] <= $limits{$yline[$il]->[1]}) || ($inter[1] <= $limits{$yline[$il]->[0]} && $inter[1] >= $limits{$yline[$il]->[1]})) {
			    $flag = 1;
			    #print "Is in chip ... \n";
			    last;
			}
		    }
		}
		
		# inside ?
		if ($flag == 1) {
		    push(@crossed_chips,$chip);
		}

	    }
	} 
    } elsif ($instrument eq "MEGACAM" || $instrum eq "MEGAPRIME") {
	#print "Working on MEGACAM \n";
	if ($period == 1) {
	    my @lchip = (1,2,3,4,5,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36);
	    foreach(@lchip) {
		#$chip = 11;
		#print "Working on chip $_ **** \n";
		
		my $chip = $_;
		my %limits = get_chippix_mosaic_instrum($period,$chip,$instrument);
		
		# Loop on the chip sides
		my $flag = 0;
		for ($il=1;$il<=4;$il++) {
		    #print "Working on side $il \n";
		    
                    # calculate equation
		    my @p1 = ($limits{$xline[$il]->[0]},$limits{$yline[$il]->[0]});
		    my @p2 = ($limits{$xline[$il]->[1]},$limits{$yline[$il]->[1]});
		    my @ref_eq =  get_hougheq(\@p1,\@p2,$ref);
		    
		    my @tmp1 = @$line;
		    my @tmp2 = @$ref;

		    
		    my @inter = get_intersect_hough($line,\@ref_eq,$ref);    
		    
		    if ($inter[0] =~ /NaN/) {
			next;
		    }

		    # is it in the chip ?
		    if (($inter[0] >= $limits{$xline[$il]->[0]} && $inter[0] <= $limits{$xline[$il]->[1]}) || ($inter[0] <= $limits{$xline[$il]->[0]} && $inter[0] >= $limits{$xline[$il]->[1]})) {
			if (($inter[1] >= $limits{$yline[$il]->[0]} && $inter[1] <= $limits{$yline[$il]->[1]}) || ($inter[1] <= $limits{$yline[$il]->[0]} && $inter[1] >= $limits{$yline[$il]->[1]})) {
			    $flag = 1;
			    # print "YES is in chip \n";
			    last;
			}
		    }
		}
		
		# inside ?
		if ($flag == 1) {
		    push(@crossed_chips,$chip);
		}
	       
	    }
	    
	    
	    
	}
    } elsif ($instrument eq "WFI") {
	#print "Working on MEGACAM \n";
	if ($period == 1) {
	    my @lchip = (1,2,3,4,5,7,8);
	    foreach(@lchip) {
		#$chip = 11;
		#print "Working on chip $_ **** \n";
		
		my $chip = $_;
		my %limits = get_chippix_mosaic_instrum($period,$chip,$instrument);
		
		# Loop on the chip sides
		my $flag = 0;
		for ($il=1;$il<=4;$il++) {
		    #print "Working on side $il \n";
		    
                    # calculate equation
		    my @p1 = ($limits{$xline[$il]->[0]},$limits{$yline[$il]->[0]});
		    my @p2 = ($limits{$xline[$il]->[1]},$limits{$yline[$il]->[1]});
		    my @ref_eq =  get_hougheq(\@p1,\@p2,$ref);
		    
		    my @tmp1 = @$line;
		    my @tmp2 = @$ref;

		    
		    my @inter = get_intersect_hough($line,\@ref_eq,$ref);    
		    
		    if ($inter[0] =~ /NaN/) {
			next;
		    }

		    # is it in the chip ?
		    if (($inter[0] >= $limits{$xline[$il]->[0]} && $inter[0] <= $limits{$xline[$il]->[1]}) || ($inter[0] <= $limits{$xline[$il]->[0]} && $inter[0] >= $limits{$xline[$il]->[1]})) {
			if (($inter[1] >= $limits{$yline[$il]->[0]} && $inter[1] <= $limits{$yline[$il]->[1]}) || ($inter[1] <= $limits{$yline[$il]->[0]} && $inter[1] >= $limits{$yline[$il]->[1]})) {
			    $flag = 1;
			    # print "YES is in chip \n";
			    last;
			}
		    }
		}
		
		# inside ?
		if ($flag == 1) {
		    push(@crossed_chips,$chip);
		}
	       
	    }
	    
	    
	    
	}
    } 


    return @crossed_chips;
}

######################################################################
# Check which chip is crossed by the line
######################################################################
sub check_linechip_instrum {
    my ($line,$ref,$instrument,$period) = @_;
    my $il = -1;
    my @crossed_chips = ();
    
    my @xline = (); my @yline= ();
    push(@{$xline[1]},("X_1_1","X_X_1"));
    push(@{$xline[2]},("X_X_1","X_X_Y"));
    push(@{$xline[3]},("X_1_Y","X_X_Y"));
    push(@{$xline[4]},("X_1_1","X_1_Y"));
    push(@{$yline[1]},("Y_1_1","Y_X_1"));
    push(@{$yline[2]},("Y_X_1","Y_X_Y"));
    push(@{$yline[3]},("Y_1_Y","Y_X_Y"));
    push(@{$yline[4]},("Y_1_1","Y_1_Y"));
    
    # CCD configurations
    my @lchip = ();
    #@ if ($instrument eq "CFH12K") {
    #@ 	if ($period == 1) {
    #@ 	    @lchip = (1,2,3,4,5,7,8,9,10,11);
    #@ 	} else {
    #@ 	    @lchip = (1,2,3,4,5,6,7,8,9,10,11,12);
    #@ 	}
    #@ } elsif ($instrument eq "MEGACAM" || $instrum eq "MEGAPRIME") {
    #@ 	@lchip = (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36);
    #@ } elsif ($instrument eq "WFI") {
    #@ 	@lchip = (1,2,3,4,5,6,7,8);
    #@ }

    my %dat; my $i;
    &get_param($instrum,\%dat);
    my @miss = get_missing_chips($instrum);
    my $nchips = $dat{"NCHIPS"};
    for($i = 1;$i<=$nchips;$i++) {
	foreach(@miss) {
	    if ($_ == $i) {
		next;
	    }
	}
	push(@lchip,$i);
    }
    
    


    foreach(@lchip) {
	#$chip = 11;
	#print "Working on chip $_ **** \n";
	
	my $chip = $_;
	my %limits = get_chippix_mosaic_instrum($period,$chip,$instrument);
	
	# Loop on the chip sides
	my $flag = 0;
	for ($il=1;$il<=4;$il++) {
	    #print "Working on side $il \n";
	    
	    # calculate equation
	    my @p1 = ($limits{$xline[$il]->[0]},$limits{$yline[$il]->[0]});
	    my @p2 = ($limits{$xline[$il]->[1]},$limits{$yline[$il]->[1]});
	    my @ref_eq =  get_hougheq(\@p1,\@p2,$ref);
	    
	    my @tmp1 = @$line;
	    my @tmp2 = @$ref;
	    
	    
	    my @inter = get_intersect_hough($line,\@ref_eq,$ref);    
	    
	    if ($inter[0] =~ /NaN/) {
		next;
	    }
	    
	    # is it in the chip ?
	    if (($inter[0] >= $limits{$xline[$il]->[0]} && $inter[0] <= $limits{$xline[$il]->[1]}) || ($inter[0] <= $limits{$xline[$il]->[0]} && $inter[0] >= $limits{$xline[$il]->[1]})) {
		if (($inter[1] >= $limits{$yline[$il]->[0]} && $inter[1] <= $limits{$yline[$il]->[1]}) || ($inter[1] <= $limits{$yline[$il]->[0]} && $inter[1] >= $limits{$yline[$il]->[1]})) {
		    $flag = 1;
		    #print "YES is in chip \n";
		    last;
		}
	    }
	}
	
	# inside ?
	if ($flag == 1) {
	    push(@crossed_chips,$chip);
	}
    } 

    return @crossed_chips;
}
######################################################################
# Order the points list for a polygon
#############################
sub get_point_order {
    my ($p1,$p2,$p3,$p4,$o1,$o2,$o3,$o4) = @_;
    
    my @list = ($p1,$p2,$p3,$p4);

    my $Cx = 0.25*($p1->[0]+$p2->[0]+$p3->[0]+$p4->[0]);
    my $Cy = 0.25*($p1->[1]+$p2->[1]+$p3->[1]+$p4->[1]);
    
    my $i = 0;
    my %list_angles;
    $list_angles{$i}=0.5*atan2($p1->[1]-$Cy,$p1->[0]-$Cx);
    $i++;
    $list_angles{$i}=0.5*atan2($p2->[1]-$Cy,$p2->[0]-$Cx);
    $i++;
    $list_angles{$i}=0.5*atan2($p3->[1]-$Cy,$p3->[0]-$Cx);
    $i++;
    $list_angles{$i}=0.5*atan2($p4->[1]-$Cy,$p4->[0]-$Cx);
    
    @keys = keys(%list_angles);

    @sorted = sort {$list_angles{$a} <=> $list_angles{$b}} @keys;

    $o1->[0] = $list[$sorted[0]]->[0];
    $o1->[1] = $list[$sorted[0]]->[1];
    $o2->[0] = $list[$sorted[1]]->[0];
    $o2->[1] = $list[$sorted[1]]->[1];
    $o3->[0] = $list[$sorted[2]]->[0];
    $o3->[1] = $list[$sorted[2]]->[1];
    $o4->[0] = $list[$sorted[3]]->[0];
    $o4->[1] = $list[$sorted[3]]->[1];

}
######################################################################
sub min {
    my $min = 10e999;
    foreach (@_) {
	if ($_ < $min) {
	    $min = $_;
	}
    }

    return $min;
}
######################################################################
# Transform a hough eq from one referential to another 
######################################################################
sub trans_ref {
    my ($old_ref,$new_ref,$eq) = @_;
    my ($ox,$oy) = @$old_ref;
    my ($nx,$ny) = @$new_ref;
    my ($eq1,$eq2) = @$eq;
    
    # calculate new distance to the line (angle remains the same)
    # O = coord new_ref    R = coord old ref   T = intesection line/OR
    my $OT_th = atan2($oy-$ny,$ox-$nx);
    my $OR = sqrt(($oy-$ny)*($oy-$ny) + ($ox-$nx)*($ox-$nx));

    my $TR = - $eq1 / cos($OT_th - $eq2);
    my $TO = -($OR - $TR);

    my $eq1 = $eq1 * ($TO / $TR);
    $eq->[0] = $eq1;
    $eq->[2] = $eq2;
    
}
######################################################################
sub read_progs {
    my ($progs,$ini) = @_;
    
    open(INI,$ini) ||die "Impossible to open $ini \n"; ;
    while (defined($oneline=<INI>)) {
	next if ($oneline=~/\A\#/);

	if ($oneline =~ /(.*)=(.*)/) {
	    $progs->{$1} = $2;
	}
    }
    close INI;
}
######################################################################


1;

