#!/usr/bin/perl -w

if(defined $ENV{'PERL_LIB'}) {
        push(@INC,$ENV{'PERL_LIB'});
}

if(defined $ENV{'PERL_PACK'}) {
        use lib $ENV{'PERL_PACK'};
}

use PGPLOT;
use PDL;
use PDL::Graphics::PGPLOT::Window;
use PDL::ImageND;
$homedir = $ENV{'HOME'};
push(@INC,"$homedir/perl/lib");

# require "header_utils.pl";
require "cat_utils.pl";
require "math_utils.pl";

use Getopt::Long;
GetOptions("im=s", \$im,          
           "out=s", \$out,         
           "reg=s", \$reg);   




# Read the fits file in a 2D-array
#@array = ();
#($rao,$line) = get_array($im,\@array);


@x = (100,500,500,1);
@y = (1,1,500,500);
@size = (10,7);

#$array = rfits $image;
$array = rfits $im;
$max = $array->index(0)->index(1);

$s = $array->flat->qsort;
$min = $s->index(0);
$max = $s->index(nelem($s)-1);


print "min $min max $max \n";

#die;

#$win = PDL::Graphics::PGPLOT::Window->new({Dev=>'/xserve',AspectRatio=>3});
#$win = PDL::Graphics::PGPLOT::Window->new({Dev=>'/xserve',Size=>\@size,ny=>2,nx=>3});
$win = PDL::Graphics::PGPLOT::Window->new({Dev=>'/xserve',Size=>\@size});
# #$win->env( 1, 2000, 1, 2000,1,1,{PlotPosition => [0, 1.0, 0, 1.0]});
# $win->env( 1, 2000, 1, 2000,1,-1,{Panel=>1});
# #$win->fits_imag( $array ,-1,1);
# $win->imag( $array ,-100,1000,{DrawWedge=>0});
# $win->env( 1, 2000, 1, 2000,1,-1,{Panel=>2});
# $win->imag( $array ,-100,1000,{DrawWedge=>0,Panel=>2});
# $win->env( 1, 2000, 1, 2000,1,-1,{Panel=>3});
# $win->imag( $array ,-100,1000,{DrawWedge=>0,Panel=>3});
# $win->env( 1, 2000, 1, 2000,1,-1,{Panel=>4});
# $win->imag( $array ,-100,1000,{DrawWedge=>0,Panel=>4});
# $win->line(\@x,\@y);

$win->env(0, 2000, 0, 2000,1,-1,{PlotPosition => [0.1, 0.5, 0.1, 0.5]});

$array2 = rebin($array,1000,2000);
$win->imag( $array2 ,-100,1000,{DrawWedge=>0,PlotPosition => [0.1, 0.5, 0.1, 0.5]});
$win->env(0, 2000, 0, 2000,1,-1, {PlotPosition => [0.1, 0.5, 0.5, 0.9]});
$win->line(\@x, \@y, {PlotPosition => [0.1, 0.5, 0.5, 0.9]});


$win->close();

die;

#print $array[10][10]."\n";

pgbeg(0,"\xwin",0,0);
my @test=(0,1,0,0,0,1);
pgenv(1,$row,1,$line,1,1);
#pggray(\@array,$row,$line,1,$row,1,$line,1000,-100,\@test);
pggray(\@array,$row,$line,1,$row,1,$line,1000,-100,\@test);


pgend;























# ======================================================================
sub get_array {

    my($image,$array) = @_;

    my $test = rfits $image;

    print "image = $image \n";

    # Get dimensions
    my $row = $test->slice("(0),:");
    my $line = $test->slice(":,(0)");

    my $sizey = nelem($row);
    my $sizex = nelem($line);
    
    my $xsize = sclr($sizex);
    my $ysize = sclr($sizey);
    
    # print "size_image = $sizex $sizey\n";

    my $ii = 0;
    my $jj = 0;

    for ($ii = 0;$ii < $sizex;$ii++) {
        # print "column $ii \n";
        #$array->[$ii] = [ ];
        for ($jj = 0;$jj < $sizey;$jj++) {
            my $val =  at($test,$ii,$jj);
            # print "val $ii $jj = $val \n";
            $array[$ii][$jj] = $val;
        }
    }
    return ($row,$line);
}
# ================================================================



