#!/usr/lib/perl -w

# HISTORY COMMENTS (TE):
#
# I moved the utilitiy function read_catc from CFH12K_lib_port.pl to this
# file. It should contain small utility routines.

######################################################################
sub read_progs {
    my ($progs,$ini) = @_;
    
    #print "Read from $ini \n";

    open(INI,$ini) || die "Impossible to read $ini ".$ENV{"PWD"}." \n";
    while (defined($oneline=<INI>)) {
	next if ($oneline=~/\A\#/);

	#print "line = $oneline \n";

	if ($oneline =~ /(.*)=(.*)/) {
	    $path = $2;
	    while($path =~ /(.*)\$\{(.*)\}(.*)/) {
		$path = $1.$progs->{$2}.$3;
		#print "path = $path \n";
	    }
	    
	    $progs->{$1} = $path;
	    #print "prog $1 $path \n";
	}
    }
    close INI;
       
}
######################################################################

# ========================================================================     
sub read_catc {
    my($file,$data) = @_;
    @list_names = ();
    @list_cols = ();
    @list_LINES = ();

    # Read the header
    open(CAT,$file) || die "Impossible to open $file \n";;
    while(defined($oneline = <CAT>)) {
	chomp $oneline;
	$oneline =~ /\s*(.*)/;
	my @list = split(/\s+/,$1);

	if ($#list != -1 && $list[0] eq "#" && $list[1] =~ /\A\d*\Z/) {
	    push(@list_names,$list[2]);
	}
    }
    close CAT;

    # Read the file 
    open(CAT,$file);
    while(defined($oneline = <CAT>)) {
	
	chomp $oneline;
	$oneline =~ /\s*(\S.*)/ || next;;
	@list = split(/\s+/,$1);

	if ($#list != -1 && $list[0] ne "#") {
	    
	    push(@{$data->{'LINES'}},$oneline);
	    #print "$oneline \n @list_names \n";

	    $index_col = -1;
	    foreach (@list_names) {
		$index_col++;
		$name_of_list = $_;
		
		if ($list[$index_col] =~ /\A\s*0+(\d+\.\d+)/) {
		    $test = $1 + 0.0;
		    push(@{$data->{$name_of_list}},$test);
		    #print "case 1 \n";
		} elsif ($list[$index_col] =~ /\D+/ && !($list[$index_col] =~ /\A\d+\.\d*\Z/)) { 
		    push(@{$data->{$name_of_list}},$list[$index_col]);
		    #print "case 2 \n";
		} else {
		    push(@{$data->{$name_of_list}},$list[$index_col]);
		    #print "case 3 \n";
		}
	    }
	}
    }

    #@tes = @{$data->{'NUMBER_1'}};
    #print "test = @tes \n";
    return 1;
}
# ==============================================================================

1;
