/* History comments (TE):
   ======================

   05.12.2008:
   Changes in the headers which are included to make the code compile
   with g++ 4.3
*/  


#include <iostream>
#include <fstream>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include "fitslib.h"
#include "fitsio.h"

using namespace std;

int usage();
int set_pix (string infile,int xcoord,int ycoord,double val);
int set_many_pix (string infile,string pixfile);

int main(int argc, char *argv[]) {
	if (argc<3 || (argc > 3 && argc != 5)) {
		usage();
		exit(1);
	}
	
	string infile = argv[1];
	
	if (argc==3) {
		string pixfile = argv[2];
		
		if (strncmp (argv[2],"@",1)) {
			usage();
			exit(1);	
		} 
		string pixfil;
		pixfil.assign(pixfile,1,pixfile.length()-1); 
		
		set_many_pix(infile,pixfil);	
	} else {
		int xcoord = atoi(argv[2]);
		int ycoord = atoi(argv[3]);
		float val = atof(argv[4]);
		set_pix(infile,xcoord,ycoord,val);
	}
	return 0;	
}

int set_pix (string infile,int xcoord,int ycoord,double val) {
	fits infits(infile);
	infits.write_single_px(xcoord,ycoord,val);
	return 0;
}
int set_many_pix (string infile,string pixfile) {
	fits infits(infile);
	vector<int> xcoord,ycoord;
	vector<float> val;
	
	// Read the file
	ifstream file;
	file.open(pixfile.c_str());
	vector<string> keys;	
	int ycoordd;
	float vall;
	
	while (! file.eof() ) {
		int xcoordd = -1;
		file >> xcoordd >> ycoordd >> vall;	
		if (xcoordd != -1) {
			xcoord.push_back(xcoordd);
			ycoord.push_back(ycoordd);
			val.push_back(vall);
		} 
	}
	file.close();
	
	infits.write_px(xcoord,ycoord,val);
	return 0;
}


int usage (){
	cout << "Usage : setpix_val infits [xcoord ycoord val] [@pxfile]  ...\n";	
	return 0;	
}
